#!/bin/sh

# Esimerkkiskripti bash-shellille. Kytt tykaluohjelmia kurssilogon
# tekemiseksi. Tuottaa tyhakemistoon useita vliaikaisia tiedostoja
# sek lopulliset kuvat "kurssilogo.png" ja "otsikkorantu.jpg".
#
# Demonstroi skriptien tekemist, Unix-tiedostojrjestelm ja
# muutakin... (ks. kommentit demon 1 versiosta; tst ne on jo jtetty
# pois). 
#
# Demo 4:n palautustehtvn thn pitisi list sh-shellin
# ohjelmointirakenteita.


# ----------- Tm ei ota argumentteja, mutta asetetaan pari muuttujaa:

# Taustakuvan kuvasuhteeksi oletetaan noin 2x1 eli pitkulainen vaakakuva.
BGSRCIMG=kurssi.jpg
# Gamma-korjauksen parametria voi sdell tst:
GAMMAVALUE=1.0

# Tt ohjelmaa kytetn tavujen muuntamiseen ASCII-biteiksi:
BYTESTOBITSEXE=./bytes_to_bits_x86-64exe
  # (parempi olisi ollut kytt jotain skriptikielt; onnistuisikohan
  # AWKilla, en tied...)



# ----------- Ensin tehdn logokuva vaiheittain.

dd if=/dev/urandom | ./bytes_to_bits_x86-64exe | fold -w 128 | head -35 > rndbits.txt

enscript --font=Courier5 --baselineskip=-1.2 -p rndbits.ps --no-header < rndbits.txt

# Tarvitaan ImageMagick -ohjelmistopaketin palveluita.

convert -density 120 -background none rndbits.ps \
   -crop 600x200+8+4 +repage -swirl 13 +matte bits.png

convert -size 600x200 xc:white -fill black \
   -gravity center -font /usr/share/fonts/default/Type1/b018015l.pfb \
   -pointsize 125   -draw "text 0,-48 'ITKA203'" \
   -pointsize 54    -draw "text  0,48 '-Kyttjrjestelmt-'" \
   +matte \
   textmask.png

convert -compose Copy_Opacity \
  -size 600x200 \
  \( bits.png -fill black -colorize 55% \)  \
  \( textmask.png \) \
  -composite \
  finalmask.png

convert  \
   \( \
     -size 600x200 \
      plasma:blue-navy \
      \( xc:white finalmask.png -compose Over -composite -negate \) \
      -compose Copy_Opacity -composite \
   \) \
  kurssilogo_eivarjoa.png

# Varjostus olis niinku tosi kiva juttu:
convert \
    kurssilogo_eivarjoa.png \
      \( +clone  -background purple -shadow 20x1.5+4+6 \) +swap \
      -background none  -mosaic \
   \
  kurssilogo.png


# ------------ Sitten yhdistetn edell tehty logo taustakuvaan.

# Taustakuvan esiksittely, gamma-korjaus ja koon muunto:
convert $BGSRCIMG -gamma $GAMMAVALUE -resize 640 tmp.png

# Gradienttivaalennus:
composite tmp.png \
   \( -size 400x640 gradient:\#bbbbff-white -rotate -90 \)  \
   -compose Overlay taustakuva.jpg

# Yhdistminen varjostettuun logoon:
convert  -size 1024x302 xc:white \
  taustakuva.jpg  -geometry +370+0 -composite \
  kurssilogo.png  -geometry +27+27 -composite \
  -blur 0.22x0.33 -quality 88 -interlace Plane \
  otsikkorantu.jpg


# ------------- siinp se.
# Lopussa voitaisiin poistaa vliaikaiset tiedostot, mutta jtetn ne nyt...
# rm textmask.png finalmask.png tmp.png
