#!/bin/sh

# Demonstroi Bourne Shellin (sh) ohjelmointirakenteita siin mrin
# kuin niit esitelln Kyttjrjestelmt -kurssilla. Oppimistavoite
# on kirjattu opinto-oppaaseen nill sanoin: "shell-ohjelmoinnin
# perusteita". Taustalla on jo Demo1:ss opittu yksittisen
# shell-komennon antaminen. Nyt listn ohjelmoinnin perusrakenteiden
# toteutuminen shelliss. Kytetn Bourne Shelli; se on hyv ja
# laajasti kytetty shell. Googlettamalla saa tarvittaessa lis
# tietoa (kuten kaikesta)... Varsinaisia kytttarkoituksia
# shell-skripteille olisi monia, mm. ajoitetut tehtvt, automaattiset
# asennukset, login- ja log-off -asetukset ja toimenpiteet, nopeat
# prototyypit sovelluksista.

# Yleishuomio: Bourne shell on todella tarkka syntaksista,
# mm. vlilynnit ja rivinvaihdot ovat erityisen merkittvi!  Ei
# menn tss syntaksiin tarkemmin kuin esimerkkikoodina, joka
# selvsti toimii ... Tentiss syntaksin yksityiskohdilla ei ole niin
# suuri merkitys, kuten ei ohjelmoinnissa yleenskn ole kyse
# syntaksin vaan ohjelmoinnillisen rakenteen merkityksen
# ymmrtmisest.

# Argumentit
echo "Kynnistit skriptin komennolla: $0"
echo "Kaikki argumentit olivat: $@"
echo "Kaksi ensimmist argumenttia olivat: $1 $2"

# Hipsukoiden merkitys:
echo 'Mits "tst" tulostuu: $1 "$2"'

# Ehtolause:
if [ "$1" == "" ]
then
  echo Et antanut yhtn argumenttia.
  echo Pit antaa ainakin yksi\! 
  echo Ensimmisen argumentin tulee olla numeerinen
  exit 1
fi

# [ En nyt itsekn muista, miten oikeaoppisesti tarkistettaisiin,
#   ett argumentti on varmasti numeerinen. Hyv skripti tarkistaisi
#   tietenkin!! Kyttjn toiminnasta (eli kyttjlt tulevasta
#   sytteest) ei nimittin saa koskaan olettaa muuta kuin ett (1) hn
#   ei osaa mitn (2) hn ei ole lukenut mitn manuaalia (3) hn on
#   pahantahtoinen ja haluaa lyt tietoturva-aukon ja (4) vhintn hn
#   sytt usein vrin vaikkei kohdat (1)-(3) olisikaan tosia. Jos 
#   varautuu kaikkiin kohtiin (1)-(4) saa aikaan kyttjystvllisen 
#   ja turvallisen ohjelman...]


# Muuttujan asettaminen:
maxcount=$1

outfname=tuloste.txt

outstr=""

# Silmukkarakenne, jossa lasketaan luvut ykksest argumenttina
# annettuun:

count=1
while [ "$count" -le "$maxcount" ]
do
  outstr="$outstr $count"    # Merkkijonoon voitaisiin list osia nin.
  let count=$count+1         # aritmetiikkaa
done

echo "Muodostin juuri seuraavan merkkijonon:"
echo "$outstr"

echo "Kyn nyt lpi sen merkkijonon:"

# Silmukkarakenne, jossa kydn lpi vlilynneill erotettu lista:
for alkio in $outstr
do
  echo $alkio
done


# Ehto, joka tarkistaa tiedoston tilanteen:
if [ -f $outfname ]
then
  echo Tiedosto $outfname on jo olemassa!
  # Siskkiset rakenteet tietysti mahdollisia...
  # Ehto, jossa on looginen AND eli optio -a:
  while [ "$vastaus" "!=" "k" -a "$vastaus" "!=" "e" ]
  do
    echo "Korvataanko entinen (k/e)?"

    # Interaktiivinen skripti voisi lukea sytteen:
    read vastaus

    # Case-rakenne:
    case $vastaus in
	k|K)
	    echo "Tiedosto $outfname korvataan"
            vastaus="k"
	    ;;
	e|E)
	    echo "Ei voi suorittaa loppuun.."
	    exit 1
	    ;;
	*)
	    echo "Vastaa k tai e"
	    ;;
    esac
  done
fi

# Jos suoritus ptyy tnne, on lupa korvata tulostustiedosto.
# Kirjoitetaan sinne siis:

echo "Ajettu ajanhetkell `date`" > $outfname

# Ns. ympristmuuttujat ovat aina asetettuja; niiden nimet on usein
# ISOILLA kirjaimilla. Kaikki shellist ajetut ohjelmat saavat
# kyttns vanhempiprosessin (shellin) ympristn. Voit kytt
# niit Java- ja C-ohjelmista sek skripteist ja muistakin
# ohjelmista. Sama asia eli ympristmuuttujat (environment variables)
# toteutuu mys muissa kyttjrjestelmiss kuin Unixeissa. Se onkin
# viimeinen uusi asia Kyttjrjestelmt-kurssilla:

echo "Ajavan kyttjn kotihakemisto on $HOME" >> $outfname
echo "Tiedostojen etsintpolku on $PATH" >> $outfname

echo "------------ ja nm haluttiin tulostaa:" >> $outfname

# Tm on vanhaa tuttua jo tss vaiheessa:
for i in $outstr
do
  echo "Tulostetaan rivi $i." >> $outfname
done
